;"STEfan i dyskietka" nr. 5,6/93
;listing do artykulu "Szara skrzynka"
;plik MFP1.S asemblowac przy pomocy DEVPAC 2.2 lub nowszego






;test przerwaniania MFP generowanego przez zegar B
;procedura ta pokazuje w prosty sposob jak instalowac wlasne przerwanie zegara B wywolywane
;w okreslonej lini ekranu (w tym przykladzie w lini 150)
	
; na poczatek nalezy wlaczyc tryb supervisor
; uzyjemy do tego celu funkcji 32 ($20) GEMDOSU (opis STEfan 5,6/93)
; parametry funkcji powinny znajdowac sie na stosie
  		
		move.l  #$0,-(SP)	;odkladamy na stos wartosc 0 (parametr funkcji) 
                move.w  #$20,-(SP)	;odkladamy na stos 32 ($20) - numer funkcji 
                trap    #1		;instrukcja TRAP 1 wywoluje funkcje GEMDOS-u 
                			;o numerze i parametrach podanych na stosie

; poniewaz wywolujac funkcje systemowa odkladamy paramerty na stos, teraz nalezaloby je zdjac
; (aby uniknac zamieszania i przepelnienia stosu), w praktyce zamiast zdejmowac parametry
; dodaje sie do wskaznika stosu liczbe odpowiadajaca ich dlugosci (dodaje, bo stos rosnie w "dol",
; odkladanie na stos powoduje odejmowanie od wskaznika stosu) takie postepowanie nazywa sie 
; korekcja stosu, i nalezy je wykonywac po kazdym wywolaniu funkcji systemowej, chociaz sa wyjatki:
; PTERM0, PTERM, KEEP PROCES  		

		addq #6,SP		;korekcja stosu o 6 (bo odlozono dlugie slowo i slowo, 4+2=6)		

; teraz zajmujemy sie wlasciwa instalacja
; najpierw blokujemy przerwania

	move.w #$2700,SR

; teraz zapamietujemy adresy systemowych procedur przerwan zegara B i VBL, 
; a takze zawartosc rejestrow ukladu MFP 
; ktore bedziemy modyfikowac
	
	move.w $FF8240,old_color0	;zapamietujemy kolory ramki i tla ekranu
	move.w $FF8244,old_color2
	
	move.l $70,old_vbl		;zapamietanie adresu systemowej procedury przerwania VBL
	move.l $120,old_timer_B		;zapamietanie adresu procedury przerwania zegara B
	
	move.b $FFFA03,old_AER		;zapamietujemy zawartosc rejestrow MFP
	move.b $FFFA07,old_IERA
	move.b $FFFA09,old_IERB
	move.b $FFFA17,old_VR
	move.b $FFFA13,old_IMRA
	move.b $FFFA15,old_IMRB
	move.b $FFFA1B,old_TBCR
	move.b $FFFA21,old_TBDR

; teraz instalujemy wlasne procedury przerwan zegara B i VBL

	lea new_vbl,a0			;najpierw procedure przerwania VBL
	move.l a0,$70
	
	lea new_timer_B,a0		;a potem procedure przerwania zegara B
	move.l a0,$120

; teraz nalezy odpowiednio zaprogramowac MFP

	bclr.b #4,$FFFA03		;w rejestrze AER ustawiamy reakcje na zbocze opadajace 
	move.b #1,$FFFA07		;w rejestrze IERA zezwalamy tylko na przerwania zegara B
	move.b #0,$FFFA09		;w rejestrze IERB blokujemy inne przerwania MFP
	bset.b #3,$FFFA17		;w rejestrze VR ustawiamy programowe zakonczenie obslugi przerwania
	move.b #1,$FFFA13		;rejestry maski IMRA i IMRB ustawiamy analogicznie jak rejestry IERA i IERB,
	move.b #0,$FFFA15		;zezwalajac jedynie na przrwanie zegara B
	move.b #0,$FFFA1B		;do rejestru TBCR wpisujemy 0 (zegar B wylaczony)
	move.b #150,$FFFA21		;licznik ma liczyc od 150 do 0

; tym ktorych zdziwilo wpisywanie do rejestru TBCR wartosci 0 (stop zegara), zamiast 8 (start zegara w trybie zliczania)
; wyjasniam, ze dla naszych potrzeb zegar B musi liczyc linie od rozpoczecia wyswietlania ramki, dlatego bedzie uruchamiany kazdym
; przerwaniem VBL	

	move.w #$2300,sr

; od tej chwili wykonuje sie nasza procedura przerwania VBL i przerwania zegara B, a na ekranie, ze jego czesc ma bialy kolor, a czesc czerwony
; teraz czekamy na nacisniecie klawisza SPACE
; w tym celu porownujemy zawartosc rejestru $FFFFFC02 (zawierajacego dane przesylane z klawiatury)
; z wartoscia $39 (kod klawisza SPACE)
; komputer bedzie powtarzal porownywanie, do momentu nacisniecia klawisza SPACE

key_wait:       
	cmpi.b  #$39,$FFFFFC02.w
        bne.s   key_wait

; w wypadku gdy flaga Z zostanie ustawiona (porownanie wypadlo pozytywnie, klawisz SPACE wcisniety)
; rozkaz skoku BNE nie wykona sie, a mikroprocesor zacznie wykonywac nastepne po BNE rozkazy, czyli....

; teraz musimy po sobie posprzatac, czyli przywrocic systemowe procedury przerwan i kolory

	move.w #$2700,sr
		
	move.b old_AER,$FFFA03
	move.b old_IERA,$FFFA07
	move.b old_IERB,$FFFA09
	move.b old_VR,$FFFA17
	move.b old_IMRA,$FFFA13	
	move.b old_IMRB,$FFFA15	
	move.b old_TBCR,$FFFA1B	
	move.b old_TBDR,$FFFA21	
	
	move.l old_vbl,$70
	move.l old_timer_B,$120
	
	move.w old_color0,$FFFF8240
	move.w old_color2,$FFFF8244
	
	
	move.w #$2300,sr

; teraz  nalezy wylaczyc tryb supervisor
; uzyjemy do tego celu ponownie funkcji 32 ($20) GEMDOSU (opis STEfan 5,6/93)
; parametry funkcji powinny znajdowac sie na stosie


	
	clr.l -(sp)					;supervisor
	move.w #32,-(sp)
	trap #1
	addq.l #6,sp

; pozostalo zakonczyc program i wrocic do desktopu
; w tym celu uzyjemy funkcj PTERM0		

	clr.l -(sp)
	trap #1
; teraz nastepuja nasze procedury przerwan zegara B i VBL, ktore podstawilismy zamiast systemowych

; najpierw procedura przerwania VBL-jej zadaniem jest ustawienie numeru lini w ktorej ma wystapic
;przerwanie zzegara B, wlaczenie trybu zliczania i ustawienie koloru tla na bialy	


new_vbl:	move.b #150,$FFFA21		;i znowu ilosc impulsow (linii do odliczenia) 
		move.b #8,$FFFA1B		;start zegara w trybie zliczania 
		move.w #$777,$FFF8240		;kolor tla i ramki na bialy
		move.w #$777,$FFF8244
		rte				;powrot z przerwania

; teraz procedura przerwania zegara B
; zmienia ona kolor tla i ramki na czerwony (zmiana ta oczywiscie bedzie widoczna w liniach 150-200)
; oraz zatrzymuje zegar B (zostanie on ponownie uruchomiony podczas przerwania VBL) 
new_timer_B:	
		
		move.w #$700,$ffff8240		;tlo i ramka na modny kolor czerwony
		move.w #$700,$ffff8244
		
		move.b #0,$FFFA1b			;licznik B stop
		bclr	#0,$FFFA0f			;programowe zakonczenie obslugi przerwania
							;(kasujemy odpowiedni bit w rejestrze ISRA)
		rte					;powrot z przerwania

; na koniec trzeba znalezc miejsce, aby zapamietac adresy systemowych proceduri zawartosc modyfikowanych rejestrow
; dyrektywa dc powoduje, ze asembler zostawia "wolne miejsce" w programie o okreslonej dlugosci , dostep do niego jest mozliwy dzieki etykiecie


old_vbl: 		dc.l 0
old_timer_B:		dc.l 0

old_AER:		dc.b 0
old_IERA:		dc.b 0
old_IERB:		dc.b 0
old_VR:			dc.b 0
old_IMRA:		dc.b 0
old_IMRB:		dc.b 0
old_TBCR:		dc.b 0
old_TBDR:		dc.b 0	

old_color0:		dc.w 0
old_color2:		dc.w 0
	