;"STEfan i dyskietka" nr. 5,6/93
;listing do artykulu "Szara skrzynka"
;plik VBL2.S asemblowac przy pomocy DEVPAC 2.2 lub nowszego

;*********************************************************
;*							 *
;*  	     PROCEDURA NIE WRACA DO DESKTOPU	         *
;*       aby przerwac jej dzialanie nacisnij RESET	 *
;*********************************************************

;test przerwaniania vbl
;procedura ta pokazuje w prosty sposob jak instalowac wlasne przerwanie VBL za pomoca kolejki przerwan		

; na poczatek nalezy wlaczyc tryb supervisor
; uzyjemy do tego celu funkcji 32 ($20) GEMDOSU (opis STEfan 5,6/93)
; parametry funkcji powinny znajdowac sie na stosie
  		
		move.l  #$0,-(SP)	;odkladamy na stos wartosc 0 (parametr funkcji) 
                move.w  #$20,-(SP)	;odkladamy na stos 32 ($20) - numer funkcji 
                trap    #1		;instrukcja TRAP 1 wywoluje funkcje GEMDOS-u 
                			;o numerze i parametrach podanych na stosie

; poniewaz wywolujac funkcje systemowa odkladamy paramerty na stos, teraz nalezaloby je zdjac
; (aby uniknac zamieszania i przepelnienia stosu), w praktyce zamiast zdejmowac parametry
; dodaje sie do wskaznika stosu liczbe odpowiadajaca ich dlugosci (dodaje, bo stos rosnie w "dol",
; odkladanie na stos powoduje odejmowanie od wskaznika stosu) takie postepowanie nazywa sie 
; korekcja stosu, i nalezy je wykonywac po kazdym wywolaniu funkcji systemowej, chociaz sa wyjatki:
; PTERM0, PTERM, KEEP PROCES  		

		addq #6,SP		;korekcja stosu o 6 (bo odlozono dlugie slowo i slowo, 4+2=6)		





; teraz zajmujemy sie wlasciwa instalacja
		
;w przypadku instalacji za pomoca kolejki przerwan ustawianie maski przerwan nie jest konieczne
;aby nie wydluzac programu, rezygnujemy z powrotu do DESKTOPU !!!!!!!!!!					
; teraz instalujemy wlasna procedure przerwan VBL
	
	movea.l $456,a0		;adres kolejki przerwan
	move.w $454,d0			;dlugosc kolejki (maksymalna liczba przerwan) do d0
	subq.w #2,d0
dalej:
	move.l (a0)+,d1			;kolejna pozycja z kolejki wskazywana jest przez a0
	beq wolne			;skok do procedury instalacyjnej gdy wolne miejsce 
	dbra d0,dalej			;jesli nie, powtarzaj

nie_ma:	illegal				;jesli nie ma wolnego miejsca, przerywamy program		
		
		
		
wolne:		lea new_VBL,A1		;wyliczamy adres procedury okreslonej etykieta
					;new_VBL i przesylamy do A1
		move.l a1,(a0)		;przesylamy dlugie slowo z A0 pod adres zawarty w A1


; od tej chwili wykonuje sie nasza procedura przerwania VBL 
; zapetlamy nasz program

loop:	jmp loop


	
; teraz nastepuje nasza procedura przerwania  VBL, ktora podstawilismy w kolejke przerwan, zauwaz, ze teraz dziala myszka !


new_VBL:	
		not.w $FF8240		;;negacja koloru tla
		rts			;powrot z przerwania przez RTS !!!
		
; na koniec trzeba znalezc miejsce, aby zapamietac adresy systemowych procedur
; dyrektywa dc powoduje, ze asembler zostawia "wolne miejsce" w programie o okreslonej dlugosci , dostep do niego jest mozliwy dzieki etykiecie

old_color0:	dc.w 0			;jw. na kolor tla
