;"STEfan i dyskietka" nr. 5,6/93
;listing do artykulu "Szara skrzynka"
;plik MFP2.S asemblowac przy pomocy DEVPAC 2.2 lub nowszego






;test przerwaniania MFP generowanego przez zegar A
;procedura ta pokazuje w prosty sposob jak instalowac wlasne przerwanie zegara A wywolywane
;z okreslona czestotliwoscia (w przykladzie 5 Hz)
	
; na poczatek nalezy wlaczyc tryb supervisor
; uzyjemy do tego celu funkcji 32 ($20) GEMDOSU (opis STEfan 5,6/93)
; parametry funkcji powinny znajdowac sie na stosie
  		
		move.l  #$0,-(SP)	;odkladamy na stos wartosc 0 (parametr funkcji) 
                move.w  #$20,-(SP)	;odkladamy na stos 32 ($20) - numer funkcji 
                trap    #1		;instrukcja TRAP 1 wywoluje funkcje GEMDOS-u 
                			;o numerze i parametrach podanych na stosie

; poniewaz wywolujac funkcje systemowa odkladamy paramerty na stos, teraz nalezaloby je zdjac
; (aby uniknac zamieszania i przepelnienia stosu), w praktyce zamiast zdejmowac parametry
; dodaje sie do wskaznika stosu liczbe odpowiadajaca ich dlugosci (dodaje, bo stos rosnie w "dol",
; odkladanie na stos powoduje odejmowanie od wskaznika stosu) takie postepowanie nazywa sie 
; korekcja stosu, i nalezy je wykonywac po kazdym wywolaniu funkcji systemowej, chociaz sa wyjatki:
; PTERM0, PTERM, KEEP PROCES  		

		addq #6,SP		;korekcja stosu o 6 (bo odlozono dlugie slowo i slowo, 4+2=6)		

; teraz zajmujemy sie wlasciwa instalacja
; najpierw blokujemy przerwania

	move.w #$2700,SR

; teraz zapamietujemy adresy systemowych procedur przerwan zegara A,
; a takze zawartosc rejestrow ukladu MFP 
; ktore bedziemy modyfikowac
	
	move.w $FF8240,old_color0	;zapamietujemy kolory ramki i tla ekranu
	move.w $FF8244,old_color2
	
	move.l $134,old_timer_A		;zapamietanie adresu procedury przerwania zegara A
	
	move.b $FFFA03,old_AER		;zapamietujemy zawartosc rejestrow MFP
	move.b $FFFA07,old_IERA
	move.b $FFFA09,old_IERB
	move.b $FFFA17,old_VR
	move.b $FFFA13,old_IMRA
	move.b $FFFA15,old_IMRB
	move.b $FFFA19,old_TACR
	move.b $FFFA1f,old_TADR


; teraz nalezy odpowiednio zaprogramowac MFP

	move.b #32,$FFFA07		;w rejestrze IERA zezwalamy tylko na przerwania zegara A
	move.b #0,$FFFA09		;w rejestrze IERB blokujemy inne przerwania MFP
	bclr.b #3,$FFFA17		;w rejestrze VR ustawiamy sprzetowe zakonczenie obslugi przerwania
	move.b #32,$FFFA13		;rejestry maski IMRA i IMRB ustawiamy analogicznie jak rejestry IERA i IERB,
	move.b #0,$FFFA15		;zezwalajac jedynie na przrwanie zegara A
	
; teraz nalezy ustawic wspolczynnik podzialu i wartosc startowa licznika:
; czestotliwosc taktu MFP=F=2457.6 kHz
; poniewaz zdecydowalismy sie na mala czestotliwosc (5 Hz) generowania przerwan, zatem mozemy wybrac duzy wspolczynnik podzialu:
; np: przez 200
; teraz Fd=2457.6/200=12.28 kHz=1228 Hz
;	poniewaz czestotliwosc przerwan ma sie rownac 5 Hz
; data = 1228/5=245.6, a zatem wartosc startowa licznika powinna wynosic 246
	
	move.b #7,$FFFA19		;do rejestru TACR wpisujemy 7 (zegar A w trybie zliczania, podzial przez 200)
	move.b #246,$FFFA1f		;licznik ma liczyc od 246 do 0

;	i ustawiamy adres wektora przerwan zegara A na nasza procedure
	
	lea my_timer_A,a0
	move.l a0,$134

; 	oraz wlaczamy przerwania

	move.w #$2300,sr

; od tej chwili wykonuje sie nasza procedura przerwania VBL i przerwania zegara B, a na ekranie, ze jego czesc ma bialy kolor, a czesc czerwony
; teraz czekamy na nacisniecie klawisza SPACE
; w tym celu porownujemy zawartosc rejestru $FFFFFC02 (zawierajacego dane przesylane z klawiatury)
; z wartoscia $39 (kod klawisza SPACE)
; komputer bedzie powtarzal porownywanie, do momentu nacisniecia klawisza SPACE

key_wait:       
	cmpi.b  #$39,$FFFFFC02.w
        bne.s   key_wait

; w wypadku gdy flaga Z zostanie ustawiona (porownanie wypadlo pozytywnie, klawisz SPACE wcisniety)
; rozkaz skoku BNE nie wykona sie, a mikroprocesor zacznie wykonywac nastepne po BNE rozkazy, czyli....

; teraz musimy po sobie posprzatac, czyli przywrocic systemowe procedury przerwan i kolory

	move.w #$2700,sr
		
	move.b old_AER,$FFFA03
	move.b old_IERA,$FFFA07
	move.b old_IERB,$FFFA09
	move.b old_VR,$FFFA17
	move.b old_IMRA,$FFFA13	
	move.b old_IMRB,$FFFA15	
	move.b old_TACR,$FFFA19	
	move.b old_TADR,$FFFA1F	
	
	move.l old_timer_A,$134
	
	move.w old_color0,$FFFF8240
	move.w old_color2,$FFFF8244
	
	
	move.w #$2300,sr

; teraz  nalezy wylaczyc tryb supervisor
; uzyjemy do tego celu ponownie funkcji 32 ($20) GEMDOSU (opis STEfan 5,6/93)
; parametry funkcji powinny znajdowac sie na stosie


	
	clr.l -(sp)					;supervisor
	move.w #32,-(sp)
	trap #1
	addq.l #6,sp

; pozostalo zakonczyc program i wrocic do desktopu
; w tym celu uzyjemy funkcj PTERM0		

	clr.l -(sp)
	trap #1

; prosta procedurka przerwania, wykonywana 5 razy na sekunde

my_timer_A
	not.w $ff8240		;zaneguj kolor tla
	not.w $ff8244		;zaneguj kolor ramki
	rte			;koniec przerwania



; na koniec trzeba znalezc miejsce, aby zapamietac adresy systemowych proceduri zawartosc modyfikowanych rejestrow
; dyrektywa dc powoduje, ze asembler zostawia "wolne miejsce" w programie o okreslonej dlugosci , dostep do niego jest mozliwy dzieki etykiecie


old_timer_A:		dc.l 0

old_AER:		dc.b 0
old_IERA:		dc.b 0
old_IERB:		dc.b 0
old_VR:			dc.b 0
old_IMRA:		dc.b 0
old_IMRB:		dc.b 0
old_TACR:		dc.b 0
old_TADR:		dc.b 0	

old_color0:		dc.w 0
old_color2:		dc.w 0
