	clr.l -(sp)					;supervisor
	move.w #32,-(sp)
	trap #1
	addq.l #6,sp

	lea screen,a0
	move.l a0,d0
	and.l #$ffff00,d0
	add.l #$0100,d0
	move.w #-1,(sp)			;setscreen
	move.l d0,-(sp)
	move.l d0,-(sp)
	move.w #5,-(sp)
	trap #14
	lea 12(sp),sp
	move.w #$2700,SR
	
	move.w $FF8240,old_color0
	move.w $FF8242,old_color1
	move.w $FF8244,old_color2
	move.w $FF8246,old_color3
	
	move.l $70,old_vbl
	move.l $120,old_timer_B
	move.b $FFFA03,old_AER
	move.b $FFFA07,old_IERA
	move.b $FFFA09,old_IERB
	move.b $FFFA0F,old_VR
	move.b $FFFA13,old_IMRA
	move.b $FFFA15,old_IMRB
	move.b $FFFA1B,old_TBCR
	move.b $FFFA21,old_TBDR
	
	lea new_vbl,a0
	move.l a0,$70
	
	lea new_timer_B,a0
	move.l a0,$120
	
	bclr.b #4,$FFFA03
	move.b #1,$FFFA07
	move.b #0,$FFFA09
	bset.b #3,$FFFA0F
	move.b #1,$FFFA13	
	move.b #0,$FFFA15	
	move.b #0,$FFFA1B	
	move.b #195,$FFFA21	
	
	move.w #$2300,sr

key_wait:       
	cmpi.b  #$39,$FFFFFC02.w
        bne.s   key_wait

	move.w #$2700,sr
		
	move.b old_AER,$FFFA03
	move.b old_IERA,$FFFA07
	move.b old_IERB,$FFFA09
	move.b old_VR,$FFFA0F
	move.b old_IMRA,$FFFA13	
	move.b old_IMRB,$FFFA15	
	move.b 0,$FFFA1B	
	move.b old_TBDR,$FFFA21	
	
	move.l old_vbl,$70
	move.l old_timer_B,$120
	
	move.w old_color0,$FFFF8240
	move.w old_color1,$FFFF8242
	move.w old_color2,$FFFF8244
	move.w old_color3,$FFFF8246
	
	
	move.w #$2300,sr
	
	clr.l -(sp)					;supervisor
	move.w #32,-(sp)
	trap #1
  	addq.l #6,sp

	clr.l -(sp)
	trap #1

	
new_vbl:	
		
		movem.l d0/a0-a2,-(sp)
		move.b #195,$FFFA21		;i znowu ilosc impulsow i tryb pracy 
		move.b #8,$FFFA1B
		movem.l (sp)+,d0/a0-a2
		rte

new_timer_B:	move.w #$2700,sr
		movem.l d0/a0-a2,-(sp)
l200:		cmpi.b #190,$FFFA21			*******++
		bne l200		
	
		
		
		
		
		move.b #0,$FF820A			;50 Hz
		
		REPT 12
		
		nop
		
		ENDR		
		
		
		
		move.b #2,$FF820A			;60 Hz

		
		movem.l (sp)+,d0/a0-a2
		move.b #0,$FFFA1B
		move.w #$2300,sr
		bclr	#0,$FFFA0f			;progr. zak. przerw.
		rte

old_vbl: 		dc.l 0
old_timer_B:		dc.l 0

old_AER:		dc.b 0
old_IERA:		dc.b 0
old_IERB:		dc.b 0
old_VR:			dc.b 0
old_IMRA:		dc.b 0
old_IMRB:		dc.b 0
old_TBCR:		dc.b 0
old_TBDR:		dc.b 0	

old_color0:		dc.w 0
old_color1:		dc.w 0
old_color2:		dc.w 0
old_color3:		dc.w 0

screen:
			
			dcb.b 50000,$55	